"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
// @ts-nocheck
const react_1 = __importStar(require("react"));
const utils_js_1 = require("./utils.js");
const useCapture = true;
const shouldIgnoreElement = (ignoreElement, elementRef, target) => {
    if (elementRef && elementRef.current) {
        return elementRef.current.contains(target) === false;
    }
    if (ignoreElement) {
        return ignoreElement.contains(target) === false;
    }
    return false;
};
const Highlight = ({ ignoreElement, isActiveRef, selectedElement, onSelect, onlySelect, children, tagName, }) => {
    const elementRef = (0, react_1.createRef)();
    const activeRef = isActiveRef && isActiveRef.current;
    (0, react_1.useEffect)(() => {
        const mouseOutCallback = event => {
            const target = event.target;
            if (!activeRef)
                return;
            target.classList.remove(utils_js_1.ON_HOVER);
        };
        const mouseOverCallback = event => {
            const target = event.target;
            if (!activeRef)
                return;
            if (selectedElement && selectedElement === target)
                return;
            if (typeof onlySelect === 'function' &&
                (!target || !onlySelect(target))) {
                return;
            }
            else if (!onlySelect &&
                shouldIgnoreElement(ignoreElement, elementRef, target))
                return;
            target.classList.add(utils_js_1.ON_HOVER);
        };
        const mouseClickCallback = event => {
            const target = event.target;
            if (!activeRef)
                return;
            if (typeof onlySelect === 'function' &&
                (!target || !onlySelect(target))) {
                return;
            }
            else if (!onlySelect &&
                shouldIgnoreElement(ignoreElement, elementRef, target))
                return;
            event.preventDefault();
            event.stopPropagation();
            (0, utils_js_1.cleanupSelected)();
            target.classList.add(utils_js_1.SELECTED);
            if (onSelect)
                onSelect(target);
        };
        window.addEventListener('mouseout', mouseOutCallback, useCapture);
        window.addEventListener('mouseover', mouseOverCallback, useCapture);
        window.addEventListener('click', mouseClickCallback, useCapture);
        return () => {
            window.removeEventListener('mouseout', mouseOutCallback, useCapture);
            window.removeEventListener('mouseover', mouseOverCallback, useCapture);
            window.removeEventListener('click', mouseClickCallback, useCapture);
        };
    }, [
        elementRef.current,
        activeRef,
        ignoreElement,
        selectedElement,
        onlySelect,
    ]);
    (0, react_1.useEffect)(() => {
        if (activeRef)
            (0, utils_js_1.appendGlobalClassName)(activeRef, tagName);
    }, [activeRef]);
    const TagName = tagName || 'element-highlight';
    return children ? react_1.default.createElement(TagName, { ref: elementRef }, children) : null;
};
Highlight.disposeOfElement = element => {
    (0, utils_js_1.cleanupSelected)();
    if (element) {
        element.classList.remove(utils_js_1.SELECTED);
        element.classList.remove(utils_js_1.ON_HOVER);
    }
};
exports.default = Highlight;
