// @ts-nocheck
import React, { useRef, useState } from 'react';
import { Outlet, useRoutes, RouteObject } from 'react-router-dom';
import { DocumentHighlighter, ComponentHighlight } from '../src';
import { Template01 } from './templates';
export const routes: RouteObject[] = [
  {
    path: '/',
    element: <Layout />,
    children: [
      { index: true, element: <Home /> },
      { path: '/react', element: <HighlightReactComponent /> },
      { path: '*', element: <Home /> },
    ],
  },
];

function App() {
  let element = useRoutes(routes);

  if (typeof window === 'undefined') return null;

  return element;
}

function Layout() {
  return (
    <div>
      <Outlet />
    </div>
  );
}

function Home() {
  const isActiveRef = useRef();
  isActiveRef.current = true;

  return (
    <DocumentHighlighter
      applicationRootElement={document.body}
      isActiveRef={isActiveRef}
      onSelect={console.log}
    >
      <Template01 />
    </DocumentHighlighter>
  );
}

function HighlightReactComponent() {
  const isActiveRef = useRef();
  isActiveRef.current = true;

  return (
    <DocumentHighlighter.Component
      applicationRootElement={document.body}
      isActiveRef={isActiveRef}
      onSelect={console.log}
      onlySelectRootComponent={true}
    >
      <div>
        <header>
          <ComponentHighlight>
            <h1>Header</h1>
            <h2>Header</h2>
          </ComponentHighlight>
          <h3>Header</h3>
          <h4>Header</h4>
        </header>
      </div>
    </DocumentHighlighter.Component>
  );
}

export default App;
